# -*- coding: utf-8 -*-
u"""Guess the natural language of a text
"""

from __future__ import with_statement
from __future__ import absolute_import
import argparse
import locale
import os
import sys

import guess_language.console_mode #@UnusedImport
from io import open


def parse_args():
    parser = argparse.ArgumentParser(
        description=__doc__.strip(),
        prog=u"{} -m {}".format(os.path.basename(sys.executable),
                               u"guess_language")
    )
    parser.add_argument(u"file",
                        help=u"plain text file or “-” for stdin")
    parser.add_argument(u"-c", u"--encoding",
                        help=u"input encoding")
    parser.add_argument(u"--disable-enchant", dest=u"use_enchant",
                        action=u"store_false",
                        help=u"disable enchant")
    return parser.parse_args()


def main():
    args = parse_args()

    if args.file == u"-":
        file = sys.stdin.fileno()
        encoding = args.encoding or (
            sys.stdin.encoding if sys.stdin.isatty()
            else locale.getpreferredencoding()
        )
    else:
        file = args.file
        encoding = args.encoding or u"utf-8"

    with open(file, encoding=encoding) as f:
        text = u"".join(f.readlines())

    if not args.use_enchant:
        guess_language.use_enchant(False)
    tag = guess_language.guess_language(text)
    print tag

    return 0 if tag else 1


if __name__ == u"__main__":
    sys.exit(main())
